searchNodes=[{"ref":"Upvest.html","title":"Upvest","type":"module","doc":"An HTTP client for Upvest. All tenancy related operations must be authenticated using the API Keys Authentication, whereas all actions on a user&#39;s behalf need to be authenticated via OAuth. The API calls are built along with those two authentication objects. All API calls return either {:ok, response} or {:error, error}, and where possible succesful response are transformed into Elixir structs mapped to the corresponding Upvest API resource."},{"ref":"Upvest.html#request/4","title":"Upvest.request/4","type":"function","doc":"Executes the request and returns the response."},{"ref":"Upvest.html#version/0","title":"Upvest.version/0","type":"function","doc":"Returns the current version of the library"},{"ref":"Upvest.html#t:error/0","title":"Upvest.error/0","type":"type","doc":""},{"ref":"Upvest.html#t:headers/0","title":"Upvest.headers/0","type":"type","doc":""},{"ref":"Upvest.html#t:http_method/0","title":"Upvest.http_method/0","type":"type","doc":""},{"ref":"Upvest.html#t:response/0","title":"Upvest.response/0","type":"type","doc":""},{"ref":"Upvest.Clientele.Wallet.Signature.html","title":"Upvest.Clientele.Wallet.Signature","type":"module","doc":"Signature represents the signed wallet signature For more details, see https://doc.upvest.co/reference#kms_sign"},{"ref":"Upvest.API.html","title":"Upvest.API","type":"module","doc":"Shared utilities for interacting with the Upvest API. It contains shared implementations of endpoints methods for creating, listing, retrieving and deleting resources. Where possible, transforms the raw result from the Upvest API into a final struct. This is achieved through the use of the Upvest.Utils.to_struct/2. Intended for internal use by Upvest endpoint modules. An Upvest endpoint module is usually mappped to an Upvest resource, containing logic for interacting with the associated resource. To implement this behaviour, simply add use Upvest.API, [list_of_methods] to the top of the entity module and make sure it defines a struct mapped to the Upvest resource. The parameter to the use Upvest.API construct is a list of HTTP methods you want to expose in the module: create/2 - create a new resource retrive/2 - retrieve a resource update/3 - update a resource delete/2 - delete a resource list/1 - list all resources list_n/2 - list all resources, capped to specified limit"},{"ref":"Upvest.AuthProvider.html","title":"Upvest.AuthProvider","type":"protocol","doc":"Protocol for API keys and OAuth authentication mechanisms supported by Upvest API. This protocol requires one functions to be implemented: get_headers/4, which returns the HTTP authentation headers required by the associated endpoint."},{"ref":"Upvest.AuthProvider.html#get_headers/4","title":"Upvest.AuthProvider.get_headers/4","type":"function","doc":"Verifies the given authentication parameters and returns authorization headers (or other info) to be attached to requests."},{"ref":"Upvest.AuthProvider.html#t:t/0","title":"Upvest.AuthProvider.t/0","type":"type","doc":""},{"ref":"Upvest.Client.html","title":"Upvest.Client","type":"module","doc":"A module for composing authentication and request parameters to the Upvest API. Currently encompasses key authentication and OAuth authenticationrequired for Tenancy and CLientele APIs respetively. Generally intended to passed in as parameter to Upvest.request/4. It&#39;s implemented such that you can change the authentication parameter and retain the other configs for requests to other APIs. At a minimum, the authentication config must be present The default BASE_URL for both authentication objects is https://api.playground.upvest.co, but feel free to adjust it, in addition to additional parameters such as extra HTTP headers and http timeout on the client struct."},{"ref":"Upvest.Client.html#build_url/2","title":"Upvest.Client.build_url/2","type":"function","doc":""},{"ref":"Upvest.Client.html#new/0","title":"Upvest.Client.new/0","type":"function","doc":"Returns a new client"},{"ref":"Upvest.Client.html#new/1","title":"Upvest.Client.new/1","type":"function","doc":"Returns a new client with the given authentication"},{"ref":"Upvest.Client.html#new/2","title":"Upvest.Client.new/2","type":"function","doc":"Returns a new client with the given authentication and base url"},{"ref":"Upvest.Client.html#versioned_url/1","title":"Upvest.Client.versioned_url/1","type":"function","doc":""},{"ref":"Upvest.Client.html#t:auth/0","title":"Upvest.Client.auth/0","type":"type","doc":""},{"ref":"Upvest.Client.html#t:t/0","title":"Upvest.Client.t/0","type":"type","doc":""},{"ref":"Upvest.Utils.html","title":"Upvest.Utils","type":"module","doc":"Utility functions for Upvest"},{"ref":"Upvest.Utils.html#sprintf/2","title":"Upvest.Utils.sprintf/2","type":"function","doc":"Formats according the given string format specifier and returns the resulting string. The params argument needs to be List. Examples iex&gt; sprintf(&quot;/foo/~r/bar&quot;, &quot;hi&quot;) ...&gt; /foo/hi/bar"},{"ref":"Upvest.Utils.html#timestamp/0","title":"Upvest.Utils.timestamp/0","type":"function","doc":"Returns current timestamp in seconds"},{"ref":"Upvest.Utils.html#to_struct/2","title":"Upvest.Utils.to_struct/2","type":"function","doc":"Creates a struct from the given struct module and data Intended for transforming raw data received from Upvest to a struct. Examples iex&gt; data = %{ ...&gt; exponent: 12, ...&gt; id: &quot;51bfa4b5-6499-5fe2-998b-5fb3c9403ac7&quot;, ...&gt; metadata: %{ ...&gt; &quot;genesis&quot; =&gt; &quot;AX7fqNywVSYFBjqMiAApi1KOjAz-7JvMoFXAewyabWD1Jk2KdzFroYsqUpxSa0hh&quot; ...&gt; }, ...&gt; name: &quot;Arweave (internal testnet)&quot;, ...&gt; protocol: &quot;arweave_testnet&quot;, ...&gt; symbol: &quot;AR&quot; ...&gt; } ...&gt; to_struct([asset], Upvest.Tenancy.Asset) %Upvest.Tenancy.Asset{ exponent: 12, id: &quot;51bfa4b5-6499-5fe2-998b-5fb3c9403ac7&quot;, metadata: %{ &quot;genesis&quot; =&gt; &quot;AX7fqNywVSYFBjqMiAApi1KOjAz-7JvMoFXAewyabWD1Jk2KdzFroYsqUpxSa0hh&quot; }, name: &quot;Arweave (internal testnet)&quot;, protocol: &quot;arweave_testnet&quot;, symbol: &quot;AR&quot; }"},{"ref":"Upvest.Tenancy.Asset.html","title":"Upvest.Tenancy.Asset","type":"module","doc":"Handles operations related to Assets. You can: Retrieve an asset List all assets List specific number of assets For more details see https://doc.upvest.co/reference#assets"},{"ref":"Upvest.Tenancy.Asset.html#endpoint/0","title":"Upvest.Tenancy.Asset.endpoint/0","type":"function","doc":""},{"ref":"Upvest.Tenancy.Asset.html#list/1","title":"Upvest.Tenancy.Asset.list/1","type":"function","doc":"List all Asset"},{"ref":"Upvest.Tenancy.Asset.html#list_n/2","title":"Upvest.Tenancy.Asset.list_n/2","type":"function","doc":"List specific number of Asset"},{"ref":"Upvest.Tenancy.Asset.html#retrieve/2","title":"Upvest.Tenancy.Asset.retrieve/2","type":"function","doc":"Retrive a(n) Asset by its ID"},{"ref":"Upvest.Tenancy.Asset.html#t:t/0","title":"Upvest.Tenancy.Asset.t/0","type":"type","doc":""},{"ref":"Upvest.Tenancy.User.html","title":"Upvest.Tenancy.User","type":"module","doc":"Handles operations related to the user You can: Create a user Retrieve a user Change user password List all users List specific number of users Delete a user For more details see https://doc.upvest.co/reference#tenancy_user_list"},{"ref":"Upvest.Tenancy.User.html#change_password/4","title":"Upvest.Tenancy.User.change_password/4","type":"function","doc":"Change password for a user For more details see https://doc.upvest.co/reference#tenancy_user_password_update"},{"ref":"Upvest.Tenancy.User.html#create/3","title":"Upvest.Tenancy.User.create/3","type":"function","doc":"Create a user. For more details https://doc.upvest.co/reference#tenancy_user_create"},{"ref":"Upvest.Tenancy.User.html#delete/2","title":"Upvest.Tenancy.User.delete/2","type":"function","doc":"Delete a(n) User"},{"ref":"Upvest.Tenancy.User.html#endpoint/0","title":"Upvest.Tenancy.User.endpoint/0","type":"function","doc":""},{"ref":"Upvest.Tenancy.User.html#list/1","title":"Upvest.Tenancy.User.list/1","type":"function","doc":"List all User"},{"ref":"Upvest.Tenancy.User.html#list_n/2","title":"Upvest.Tenancy.User.list_n/2","type":"function","doc":"List specific number of User"},{"ref":"Upvest.Tenancy.User.html#retrieve/2","title":"Upvest.Tenancy.User.retrieve/2","type":"function","doc":"Retrive a(n) User by its ID"},{"ref":"Upvest.Tenancy.User.html#t:t/0","title":"Upvest.Tenancy.User.t/0","type":"type","doc":""},{"ref":"Upvest.Clientele.Transaction.html","title":"Upvest.Clientele.Transaction","type":"module","doc":"Handles operations related to user transactions You can: Create new transaction List all transactions List specific number of transactions For more details see https://doc.upvest.co/reference#kms_transaction_list"},{"ref":"Upvest.Clientele.Transaction.html#create/7","title":"Upvest.Clientele.Transaction.create/7","type":"function","doc":""},{"ref":"Upvest.Clientele.Transaction.html#endpoint/0","title":"Upvest.Clientele.Transaction.endpoint/0","type":"function","doc":""},{"ref":"Upvest.Clientele.Transaction.html#list/1","title":"Upvest.Clientele.Transaction.list/1","type":"function","doc":"List all Transaction"},{"ref":"Upvest.Clientele.Transaction.html#list_n/2","title":"Upvest.Clientele.Transaction.list_n/2","type":"function","doc":"List specific number of Transaction"},{"ref":"Upvest.Clientele.Transaction.html#retrieve/2","title":"Upvest.Clientele.Transaction.retrieve/2","type":"function","doc":"Retrive a(n) Transaction by its ID"},{"ref":"Upvest.Clientele.Transaction.html#t:t/0","title":"Upvest.Clientele.Transaction.t/0","type":"type","doc":""},{"ref":"Upvest.Clientele.Wallet.html","title":"Upvest.Clientele.Wallet","type":"module","doc":"Handles operations related to Wallet You can: Retrieve wallet List all wallets List specific number of wallets For more details see https://doc.upvest.co/reference#kms_wallet_list"},{"ref":"Upvest.Clientele.Wallet.html#create/5","title":"Upvest.Clientele.Wallet.create/5","type":"function","doc":"Create a new wallet. The password is necessary to decrypt the Seed data to create the private key for the new wallet, and then to encrypt the new private key."},{"ref":"Upvest.Clientele.Wallet.html#endpoint/0","title":"Upvest.Clientele.Wallet.endpoint/0","type":"function","doc":""},{"ref":"Upvest.Clientele.Wallet.html#list/1","title":"Upvest.Clientele.Wallet.list/1","type":"function","doc":"List all Wallet"},{"ref":"Upvest.Clientele.Wallet.html#list_n/2","title":"Upvest.Clientele.Wallet.list_n/2","type":"function","doc":"List specific number of Wallet"},{"ref":"Upvest.Clientele.Wallet.html#retrieve/2","title":"Upvest.Clientele.Wallet.retrieve/2","type":"function","doc":"Retrive a(n) Wallet by its ID"},{"ref":"Upvest.Clientele.Wallet.html#sign/6","title":"Upvest.Clientele.Wallet.sign/6","type":"function","doc":"Sign (the hash of) data with the private key corresponding to this wallet."},{"ref":"Upvest.Clientele.Wallet.html#t:t/0","title":"Upvest.Clientele.Wallet.t/0","type":"type","doc":""},{"ref":"Upvest.Authentication.KeyAuth.html","title":"Upvest.Authentication.KeyAuth","type":"module","doc":""},{"ref":"Upvest.Authentication.OAuth.html","title":"Upvest.Authentication.OAuth","type":"module","doc":""},{"ref":"Upvest.APIConnectionError.html","title":"Upvest.APIConnectionError","type":"exception","doc":"Failure to connect to the Upvest API. Network issues, timeouts etc"},{"ref":"Upvest.APIConnectionError.html#t:t/0","title":"Upvest.APIConnectionError.t/0","type":"type","doc":""},{"ref":"Upvest.APIError.html","title":"Upvest.APIError","type":"exception","doc":"API errors cover any other type of problem, such as: Internal Server Error: Something went wrong on Upvest&#39;s end. Service Unavailable."},{"ref":"Upvest.APIError.html#t:t/0","title":"Upvest.APIError.t/0","type":"type","doc":""},{"ref":"Upvest.AuthenticationError.html","title":"Upvest.AuthenticationError","type":"exception","doc":"Unauthorized: missing API key or invalid API key provided."},{"ref":"Upvest.AuthenticationError.html#t:t/0","title":"Upvest.AuthenticationError.t/0","type":"type","doc":""},{"ref":"Upvest.InvalidRequestError.html","title":"Upvest.InvalidRequestError","type":"exception","doc":"Bad Request: often due to missing a required parameter 422, Unprocessable entity. The request could not be processed. 404 - Not found"},{"ref":"Upvest.InvalidRequestError.html#t:t/0","title":"Upvest.InvalidRequestError.t/0","type":"type","doc":""},{"ref":"Upvest.PermissionError.html","title":"Upvest.PermissionError","type":"exception","doc":"No permission to access resource"},{"ref":"Upvest.PermissionError.html#t:t/0","title":"Upvest.PermissionError.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Upvest Elixir","type":"extras","doc":"Upvest Elixir Elixir library for the Upvest API. In order to retrieve your API credentials for using this Go client, you&#39;ll need to sign up with Upvest."},{"ref":"readme.html#installation","title":"Upvest Elixir - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding upvest to your list of dependencies in mix.exs: def deps do [ {:upvest, &quot;~&gt; 0.1.0&quot;} ] end Alternatively, you can install the library by a particular commit reference: def deps do [ {:upvest, git: &quot;https://github.com/rpip/upvest-elixir&quot;, ref: &quot;commit ref here&quot;} ] end"},{"ref":"readme.html#usage","title":"Upvest Elixir - Usage","type":"extras","doc":"Where possible, the services available on the client groups the API into logical chunks and correspond to the structure of the Upvest API documentation. All tenancy related operations must be authenticated using the API Keys Authentication, whereas all actions on a user&#39;s behalf need to be authenticated via OAuth. The API calls are built along with those two authentication objects. All API calls return either {:ok, response} or {:error, error}, and where possible succesful response are transformed into Elixir structs mapped to the corresponding Upvest API resource. Tenancy API - API Keys Authentication The Upvest API uses the notion of tenants, which represent customers that build their platform upon the Upvest API. The end-users of the tenant (i.e. your customers), are referred to as clients. A tenant is able to manage their users directly and is also able to initiate actions on the user&#39;s behalf (create wallets, send transactions). alias Upvest.Client alias Upvest.Authentication.KeyAuth alias Upvest.Tenancy.User keyauth = %KeyAuth{ api_key: your_api_key, api_secret: your_api_secret, api_passphrase: your_api_passphrase } client = Client.new(keyauth) # create a user with {:ok, user} &lt;- User.create(client, username, password) do # do something with new user created else {:error, error} -&gt; # handle the error end # list users {:ok, users} = User.list(client) # retrieve 200 users {:ok, users} = User.list_n(client, 200) # change password {:ok, user} = User.change_password(client, username, current_password, new_password) Clientele API - OAuth Authentication The authentication via OAuth allows you to perform operations on behalf of your user. For more information on the OAuth concept, please refer to our documentation. Again, please retrieve your client credentials from the Upvest account management. Next, create a Client with your Upvest OAuth in order to authenticate your API calls on behalf of a user: alias Upvest.Client alias Upvest.Authentication.OAuth alias Upvest.Clientele.Wallet oauth = %OAuth{ client_id: client_id, client_secret: client_secret, username: your_users_username, password: your_users_password } # If you already have a client created with a key auth # you can create a new oauth client from that by changing the auth param client = %{client | auth: oauth} # alternatively, client = Client.new(oauth) with {:ok, wallet} &lt;- Wallet.create(client, user_password, asset_id) do # handle new wallet created else {:error, error} -&gt; # handle error end"},{"ref":"readme.html#error-handling","title":"Upvest Elixir - Error handling","type":"extras","doc":"In case there is an error, the response is {:error, error} where error is one of: Upvest.APIConnectionError Upvest.AuthenticationError Upvest.InvalidRequestError Upvest.PermissionError Upvest.APIError For example, using already taken username will return the error: {:error, %Upvest.APIError{ code: 409, details: [ %{ &quot;domain&quot; =&gt; &quot;clientele&quot;, &quot;location&quot; =&gt; &quot;username&quot;, &quot;locationType&quot; =&gt; &quot;parameter&quot;, &quot;message&quot; =&gt; &quot;Duplicate Value&quot;, &quot;reason&quot; =&gt; &quot;duplicateValue&quot; } ], message: &quot;User with given username exists already&quot;, type: &quot;api_error&quot; }}"},{"ref":"readme.html#building-docs","title":"Upvest Elixir - Building docs","type":"extras","doc":"$ MIX_ENV=docs mix docs"},{"ref":"readme.html#running-tests","title":"Upvest Elixir - Running tests","type":"extras","doc":"Clone the repo and fetch its dependencies: $ git clone https://github.com/rpip/upvest-elixir $ cd upvest-elixir $ mix do deps.get, compile $ mix test"},{"ref":"readme.html#development","title":"Upvest Elixir - Development","type":"extras","doc":"Code must be nicely formatted: mix format All types, structs and functions should be documented. Ensure that mix test succeeds. Set up config settings via environment variables, ideally in a .env file you can source: # Set your tenancy API key information here. export API_KEY=xxxx export API_SECRET=xxxx export API_PASSPHRASE=xxxx # Set your OAuth2 client information here. export OAUTH2_CLIENT_ID=xxxx export OAUTH2_CLIENT_SECRET=xxxx"},{"ref":"readme.html#test","title":"Upvest Elixir - Test","type":"extras","doc":"Run all tests: mix test Run a single test: mix test test/wallet_test.exs"},{"ref":"readme.html#more","title":"Upvest Elixir - More","type":"extras","doc":"For a comprehensive reference, check out the Upvest documentation. For details on all the functionality in this library, see the HexDocs documentation."}]